using System;
using Qyoto;

namespace test {
	
	public class MainWindow : QMainWindow {
		
		public QWidget mainWidget;
		public QStackedWidget stack;
		public QWidget startPage;
		public QWidget secondPage;
	    public QVBoxLayout mainLayout;
		public QPushButton btnAbout;
		
		private StartWindowUI startWin;
		private SecondWindowUI secondWin;

		public MainWindow() {
			InitUI();
		}
		
		public void InitUI() {
			this.WindowTitle = "Test";
			mainWidget = new QWidget(this);
			stack = new QStackedWidget(mainWidget);
		    startPage = new QWidget();
			stack.SetCurrentIndex(0);
			stack.AddWidget(startPage);
			
			startWin = new StartWindowUI();
			startWin.StartUI(this, startPage);
			
			mainLayout = new QVBoxLayout(mainWidget);
			mainLayout.AddWidget(stack);

			mainWidget.SetLayout(mainLayout);
			this.SetCentralWidget(mainWidget);

			Connect(startWin.btnAbout, SIGNAL("clicked()"), this, SLOT("ShowAbout()"));
			Connect(startWin.btnStart, SIGNAL("clicked()"), this, SLOT("GoToPage2()"));
		}
		
		[Q_SLOT]
		private void ShowAbout() {
			QMessageBox.About(this, "About", "This is QStackedWidget page No " + stack.CurrentIndex.ToString());
		}
		
		[Q_SLOT]
		private void GoToPage1() {
			stack.RemoveWidget(stack.CurrentWidget());
			stack.SetCurrentIndex(0);
			this.WindowTitle = "Start";
		}
		
		[Q_SLOT]
		private void GoToPage2() {
		    secondPage = new QWidget();
			stack.AddWidget(secondPage);
			stack.SetCurrentIndex(1);
			secondWin = new SecondWindowUI();
			secondWin.SecondUI(this, secondPage);
			Connect(secondWin.btnAbout, SIGNAL("clicked()"), this, SLOT("ShowAbout()"));
			Connect(secondWin.btnSecond, SIGNAL("clicked()"), this, SLOT("GoToPage1()"));
		}
	}
}